#include <cstdio>
#include <set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstring>
#include <ctime>
using namespace std;
#define NAME "accounts"

long long gcd(long long a, long long b) {
    while (a != 0) {
        b %= a;
        swap(a, b);
    }
    return b;
}

const int N = 1e5 + 10;
const int M = 3e5 + 10;

vector <int>  indexes[M];
vector <long long> values[M];
vector <pair <int, long long> > hints[N];
long long b[N], gc[N];
long long t[M];
int useAcc[N], useHint[M], it;

bool dfs(int v) {
    useAcc[v] = it;
    for (int i = 0; i < hints[v].size(); ++i) {
        int to = hints[v][i].first;
        long long val = hints[v][i].second;
        if (val % b[v] != 0)
            return false;
        if (useHint[to] == it) {
            if (t[to] != val / b[v])
                return false;
        } else {
            t[to] = val / b[v];
            useHint[to] = it;
            for (int j = 0; j < indexes[to].size(); ++j) {
                if (values[to][j] % t[to] != 0)
                    return false;
                if (useAcc[indexes[to][j]] == it) {
                    if (values[to][j] / t[to] != b[indexes[to][j]])
                        return false;
                } else {
                    b[indexes[to][j]] = values[to][j] / t[to];
                    if (!dfs(indexes[to][j]))
                        return false;
                }
            }
        }
    }
    return true;
}


bool check(int v, long long val) {
    ++it;
    b[v] = val;
    return dfs(v);
}

int main() {
    int l = clock();
    freopen(NAME".in", "r", stdin);
    freopen(NAME".out", "w", stdout);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int ki;
        scanf("%d", &ki);
        indexes[i] = vector <int>(ki);
        values[i] = vector <long long>(ki);
        for (int j = 0; j < ki; ++j) {
            int id;
            long long val;
            scanf("%d%I64d", &id, &val);
            --id;
            indexes[i][j] = id;
            values[i][j] = val;
            hints[id].push_back(make_pair(i, val));
            if (gc[id] == 0)
                gc[id] = val;
            else
                gc[id] = gcd(gc[id], val);
        }
    }

    for (int i = 0; i < n; ++i)
        if (b[i] == 0) {
            long long g = gc[i];
            bool found = false;
            for (long long d = 1; d * d <= g; ++d)
                if (g % d == 0) {
                    found = check(i, d);
                    if (found) break;
                    found = check(i ,g / d);
                    if (found) break;
                }
            if (g == 0) {
                b[i] = 1;
                continue;
            }
            if (!found) {
                cout << "NO";
                return 0;
            }
        }
    cout << "YES\n";
    for (int i = 0; i < n; ++i)
        printf("%I64d ", b[i]);
    cerr << "time = " << (clock() - l) * 1.0 / CLOCKS_PER_SEC << endl;
    return 0;
}
