import java.io.*;
import java.util.*;

public class TestGen {

    static PrintWriter out;
    static Random rnd = new Random(0);
    static int tNumber = 1;
    static PrintWriter testDescr;
    static int sb = 0;

    static void printTest(int n, int[] a, String comment, int points) throws IOException {
        System.out.println(String.format("Generating test %d", tNumber));
        if (tNumber < 10)
            out = new PrintWriter("../tests/0" + tNumber);
        else
            out = new PrintWriter("../tests/" + tNumber);
        out.println(n);
        for (int i = 0; i < n; i++) {
            out.print(a[i]);
            if (i != n - 1)
                out.print(" ");
        }
        out.println();
        out.close();
        testDescr.println("../tests/" + ((tNumber > 9) ? tNumber : ("0" + tNumber)) + ", folder=tests, subtask=subtask" + sb + ", points=" + points + ", comment=\"" + comment + "\"");
        tNumber++;        
    }
    
    static void genSample() throws FileNotFoundException {
        out = new PrintWriter("../preliminary/01");        
        out.println(5);
        out.println(3 + " " + 2 + " " + 2 + " " + 5 + " " + 4);
        out.close();                
        testDescr.println("../preliminary/01, folder=preliminary, subtask=subtask0, points=0, comment=\"sample 1\"");
    }
    
    static int randFromTo(int l, int r) {
        return rnd.nextInt(r - l + 1) + l;      
    }

    static int[] genArray(int n, int mn, int mx) {
        int[] ans = new int[n];
        for (int i = 0; i < n; i++) 
            ans[i] = randFromTo(mn, mx);
        return ans;       
    }
    
    public static void main(String[] args) throws IOException {
        new File("../preliminary").mkdir();
        new File("../tests").mkdir();        
        testDescr = new PrintWriter("../tests.desc");
        genSample();
        sb = 1;
        final int points = 4;
        {
            int n = 1;
            int[] a = genArray(n, 1, 10);
            printTest(n, a, "mintest: n=" + n, points);    
        }
        for (int i = 0; i < 5; ++i) {
            int n = 10;
            int[] a = genArray(n, 5, 20);
            printTest(n, a, "n=" + n, points);
        }
        for (int i = 0; i < 5; ++i) {
            int n = 50;
            int[] a = genArray(n, 50, 100);
            printTest(n, a, "n=" + n, points);
        }
        for (int i = 0; i < 5; ++i) {
            int n = 100;
            int[] a = genArray(n, 100, 1000);
            printTest(n, a, "n=" + n, points);
        }
        for (int i = 0; i < 5; ++i) {
            int n = 1000;
            int[] a = genArray(n, 100, 1000);
            printTest(n, a, "n=" + n, points);
        }
        {
            int n = 1000;
            int[] a = genArray(n, 1000, 1000);
            printTest(n, a, "maxtest: n=" + n, points);    
        }
        {
            int n = 1000;
            int[] a = genArray(n, 1, 1000);
            printTest(n, a, "maxtest: n=" + n, points);    
        }
        {
            int n = 1000;
            int[] a = genArray(n, 1, 1);
            printTest(n, a, "maxtest: n=" + n, points);    
        }
        {
            int n = 1000;
            int[] a = genArray(n, 1, 1);
            a[n - 1] = 1000;
            printTest(n, a, "maxtest: n=" + n, points);    
        }
        testDescr.println("comment_subtask1=\"full limits\"\nbonus_subtask1=0");
        testDescr.close();
    }                 
    
}
