import random
import math
random.seed("personal07_and_ioip")

class TestGen:
    def __init__(self):
        self.test_number = 0
        self.desc_file = open("../tests.desc", "w")

    def generate_samples(self):
        self.print_test(2, [3], [[1, 2], [1, 1], [3, 0], [3, 1], [3, 2]], "subtask0", "test from sample", 0, "preliminary")
        self.print_test(2, [1, 2], [[3, 0], [3, 1], [2], [3, 0], [1, 3], [3, 0], [3, 1]], "subtask0", "test from sample", 0, "preliminary")

    def generate_max_tests(self, maxn, subtask):
        n = maxn
        x = 10**9
        moods = []
        for i in range(n):
            moods.append(1)
        queries = []
        m = maxn
        for i in range(m // 2):
            queries.append([1, 1])
            queries.append([3, n + i])
        self.print_test(x, moods, queries, subtask, "max test, x = 10^9, n = %d, m = %d, all moods are 1" % (n, m))

        n = maxn
        x = 1
        moods = []
        for i in range(n):
            moods.append(10**9)
        queries = []
        m = maxn
        for i in range(m // 2):
            queries.append([1, 10**9])
            queries.append([3, n + i])
        self.print_test(x, moods, queries, subtask, "max test, x = 1, n = %d, m = %d, all moods are 10^9" % (n, m))
        
        n = maxn
        x = 10**9 // 2
        moods = []
        for i in range(n):
            moods.append(10**9)
        queries = []
        m = maxn
        for i in range(m // 2):
            queries.append([1, 1])
            queries.append([3, n + i])
        self.print_test(x, moods, queries, subtask, "max test, x = 10^9/2, n = %d, m = %d, first moods are 10^9, other are 1" % (n, m))

        n = maxn
        x = 10**9 // 2
        moods = []
        for i in range(n):
            moods.append(1)
        queries = []
        m = maxn
        for i in range(m // 2):
            queries.append([1, 10**9])
            queries.append([3, n + i])
        self.print_test(x, moods, queries, subtask, "max test, x = 10^9/2, n = %d, m = %d, first moods are 1, other are 10^9" % (n, m))

        n = maxn 
        x = 10**9
        moods = []
        for i in range(n):
            moods.append(1)
        queries = []
        m = maxn
        for i in range(m):
            queries.append([3, n - 1])
        self.print_test(x, moods, queries, subtask, "max test, x = 10^9, n = %d, m = %d, only third type queries" % (n, m))
        
        n = maxn 
        x = 1
        moods = []
        for i in range(n):
            moods.append(10**9)
        queries = []
        m = maxn
        for i in range(m):
            queries.append([3, n - 1])
        self.print_test(x, moods, queries, subtask, "max test, x = 1, n = %d, m = %d, only third type queries" % (n, m))
            
    def full_pop_many_times_test(self, maxn, subtask):
        n = 1
        add = 1000
        if maxn == 1000:
            add = 10
        x = random.randint(0, 10**9)
        moods = [1]
        queries = [[2]]
        for i in range(24):
            for j in range(add):
                queries.append([1, random.randint(0, 10**9)])
                queries.append([3, j])
            for j in range(add):
                queries.append([3, add - j - 1])
                queries.append([2])
        self.print_test(x, moods, queries, subtask, "random test, x = %d, n = %d, m = %d, a lot of full pops of queue" % (x, len(moods), len(queries)))

    def generate_random_test(self, maxn, subtask):
        n = random.randint(1, maxn)
        x = random.randint(0, 10**9)
        moods = []
        for i in range(n):
            moods.append(random.randint(0, 10**9))
        queries = []
        peopleInQueue = n
        m = maxn
        for i in range(m):
            typeQuery = random.randint(1, 3)
            while (typeQuery == 2) and (peopleInQueue == 0):
                typeQuery = random.randint(1, 3)
            if typeQuery == 1:  
                queries.append([1, random.randint(0, 10**9)])
                peopleInQueue += 1
            elif typeQuery == 2:
                queries.append([2])
                peopleInQueue -= 1
            else:
                queries.append([3, random.randint(0, peopleInQueue - 1)])
        self.print_test(x, moods, queries, subtask, "random test, x = %d, n = %d, m = %d" % (x, len(moods), len(queries)))
                               
    def generate_first_group(self):
        for i in range(10):
            self.generate_random_test(1000, "subtask1")
        for i in range(10):
            self.full_pop_many_times_test(1000, "subtask1")
        self.generate_max_tests(1000, "subtask1")

    def generate_second_group(self):
        for i in range(10):
            self.generate_random_test(100000, "subtask2")
        for i in range(10):
            self.full_pop_many_times_test(100000, "subtask2")
        self.generate_max_tests(100000, "subtask2")

    def print_test(self, x, moods, queries, subtask, description, points=0, folder="tests"):
        self.test_number += 1
        print("Generating test %s\%d" % (subtask, self.test_number))

        test_name = "../" + folder + "/{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        n = len(moods)
        m = len(queries)
        print(n, x, file=test_file)
        print(' '.join(str(mood) for mood in moods), file=test_file)
        print(m, file=test_file)
        print('\n'.join(' '.join(str(element) for element in query) for query in queries), file=test_file)

        print(test_name + ", folder=" + folder + ", subtask=" + subtask + ", points=" + str(points) + ", comment=\"" + description + "\"", file=self.desc_file)
        test_file.close()                                                                                             

    def generate_all_tests(self):
        self.generate_samples()
        self.test_number = 0

        #First group of tests
        self.generate_first_group()       #tests 01-##
        print("comment_subtask1=\"n, m &lt;= 1000\"", file=self.desc_file)
        print("bonus_subtask1=40", file=self.desc_file)

        #Second group of tests
        self.generate_second_group()      #tests ##-##
        print("comment_subtask2=\"n, m &lt;= 100000 \"", file=self.desc_file)
        print("bonus_subtask2=60", file=self.desc_file)
        
        self.desc_file.close()

import os, shutil
if os.path.exists('../preliminary'):
    print('Directory preliminary already exists')
    shutil.rmtree('../preliminary', ignore_errors=False, onerror=None)
if os.path.exists('../tests'):
    print('Directory tests already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../preliminary')
    os.makedirs('../tests')
except OSError:                                                                                                                      
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
